SystemOrganization addCategory: #ConfigurationOfMabinogi!

Object subclass: #ConfigurationOfMabinogi
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMabinogi'!

!ConfigurationOfMabinogi class methodsFor: 'development support' stamp: 'StuartHerring 2/10/2012 16:46'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMabinogi class methodsFor: 'private' stamp: 'StuartHerring 2/10/2012 16:46'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMabinogi class methodsFor: 'private' stamp: 'StuartHerring 2/10/2012 16:46'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMabinogi class methodsFor: 'private' stamp: 'StuartHerring 2/10/2012 16:46'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMabinogi class methodsFor: 'metacello tool support' stamp: 'StuartHerring 2/10/2012 16:46'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMabinogi class methodsFor: 'loading' stamp: 'StuartHerring 2/10/2012 16:46'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMabinogi class methodsFor: 'loading' stamp: 'StuartHerring 2/10/2012 16:46'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMabinogi class methodsFor: 'loading' stamp: 'StuartHerring 2/10/2012 16:46'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMabinogi class methodsFor: 'accessing' stamp: 'StuartHerring 2/10/2012 16:46'!
project

	^self new project! !

!ConfigurationOfMabinogi class methodsFor: 'development support' stamp: 'StuartHerring 2/10/2012 16:46'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMabinogi methodsFor: 'baselines' stamp: 'StuartHerring 2/12/2012 13:42'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Mabinogi'.
		spec 
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Base' 'JQuery-Core') ];
		 	project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'];
			project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Mabinogi-Core';
			package: 'Mabinogi-Web' with: [
				spec requires: #('Mabinogi-Core' 'Seaside30' ). ];
			package: 'Mabinogi-Test' with: [
				spec requires: #('Mocketry' 'Mabinogi-Core' 'Mabinogi-Web' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Mabinogi-Core' );
			group: 'Tests' with: #('Mabinogi-Test' );
			group: 'Full' with: #('Core' 'Mabinogi-Web' );
			group: 'Development' with: #('Full' 'Tests' 'Seaside30 Development'). ].
! !

!ConfigurationOfMabinogi methodsFor: 'symbolic versions' stamp: 'StuartHerring 2/11/2012 10:20'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfMabinogi methodsFor: 'accessing' stamp: 'StuartHerring 2/10/2012 16:46'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMabinogi methodsFor: 'versions' stamp: 'StuartHerring 2/12/2012 20:43'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'Initial Version
Should depend on SIXX not shout - stupid copy paste error
Should depend on SIXX not shout - stupid copy paste error
Esnure tests pull in Mocketry
Tidy up dependencies a little
SC-10
Improvements to allow classes to inherit definitions, and to override base definitions.
Also added ignore mechanism	
'.
		spec author: 'StuartHerring'.
		spec timestamp: '2/12/2012 20:43'.
		spec 
			package: 'Mabinogi-Core' with: 'Mabinogi-Core-StuartHerring.5';
			package: 'Mabinogi-Web' with: 'Mabinogi-Web-StuartHerring.1';
			package: 'Mabinogi-Test' with: 'Mabinogi-Test-StuartHerring.4'. ].
! !
